function [u_vel vel_comps] = calcMotionVector(pos, x_i, GOAL)
global cGains POINT_OFFSET
    newgoal = GOAL';
    newgoal(3) = GOAL(3) + GOAL(1)*GOAL(1);
    newgoal(4) = GOAL(4) + GOAL(1)*GOAL(2);
    newgoal(5) = GOAL(5) + GOAL(2)*GOAL(2);
  
    frontpos(1) = pos(1) + POINT_OFFSET*cos(pos(3));
    frontpos(2) = pos(2) + POINT_OFFSET*sin(pos(3)); 
    
    integral = [1   0   2*frontpos(1) frontpos(2)       0    ;
                0   1           0     frontpos(1)   2*frontpos(2)];
    
    x_vel_comp = integral(1,:)*cGains.*(x_i-newgoal)';
    y_vel_comp = integral(2,:)*cGains.*(x_i-newgoal)';
    vel_comps = [x_vel_comp;y_vel_comp];
    
    u_vel = integral*cGains*(newgoal-x_i);
end

