function newPos = updatePos(pos,wheelV_ticks,dt)
global WHEELRADIUS WHEELBASE STEPS_PER_REV

wheelAngVel = (wheelV_ticks/STEPS_PER_REV)*2*pi; %ang vel per sec.

trans_dist = (sum(wheelAngVel)/2)*WHEELRADIUS*dt;

if wheelV_ticks(1)==wheelV_ticks(2)
    newPos = [pos(1)+trans_dist*cos(pos(3));
              pos(2)+trans_dist*sin(pos(3));
              pos(3)];
    
else
    %center of rotation relative to robot
    turnRadius = -WHEELBASE*(wheelV_ticks(1)+wheelV_ticks(2))...
                           /(wheelV_ticks(1)-wheelV_ticks(2));

    turnTheta = WHEELRADIUS/(2*WHEELBASE)*(wheelAngVel(2)-wheelAngVel(1))*dt;
    
    centerOfRot = [pos(1) + turnRadius*cos(pos(3)+pi/2);
                   pos(2) + turnRadius*sin(pos(3)+pi/2)];
    
	refPos = [pos(1)-centerOfRot(1);	%//move COR to origin to apply rotation transformation
              pos(2)-centerOfRot(2)];
        
    rotMat = [cos(turnTheta) -sin(turnTheta);
              sin(turnTheta)  cos(turnTheta)];
    newLocalPos = rotMat*refPos;
    
    newPos(1:2,1) = newLocalPos+centerOfRot;
    newPos(3,1) = pos(3)+turnTheta;
    if newPos(3,1) > 2*pi
        newPos(3,1) = newPos(3,1)-2*pi;
    elseif newPos(3,1) < -2*pi
        newPos(3,1) = newPos(3,1)+2*pi;
    end
    
end
